
function [w,pos, obj] = unbiased_svm_globalK()
  global K Y alpha grad C nonboundSV OBJ s Eta tol
  Eta = 1;
  % K Kernel matrix
  % Y label vector
  % alpha Lagrange Multipliers
  % grad gradient of the dual problem 
  % C SVM C
  % nonboundSV index of the Support Vectors with alpha < C
  % OBJ value of the functional
  % s output of the posterior part
  N = length(Y); % number of samples
  s = zeros(N,1); % output of the classifier
  grad = ones(N,1);
  alpha = zeros(N,1);;
nonboundSV = zeros(N,1);
  numChanged=0;
  examineAll = 1;
 aold = zeros(N,1);
  OBJ = 0;
 
  iter=0;
  while (numChanged > 0) | (examineAll)
    numChanged = 0;
    if examineAll
      [muda whichi] = sort(alpha,'descend');
      for i=1:N
        changed = examineExample(whichi(i));
        numChanged = numChanged+changed;
      end
    else
     whichi = find(((grad < -tol) & alpha > 1e-6) | ((grad > tol)&(alpha < C-1e-10)));
     for ii=1:length(whichi)
        i = whichi(ii);
        changed = examineExample(i);
        numChanged = numChanged+changed;
      end
    end
    iter=iter+1;
    if iter >= 100*N; 
      disp('Max Iteration threshold crossed');
      tol = tol*10;
      fprintf('now tolerance = %f\n',tol);
      iter=1;
    end
    
    if examineAll == 1
      examineAll = 0;
       
    elseif numChanged <=10
      examineAll = 1;
    end
   
   
    
  end
  pos = find(alpha > 0);
  w=Y(pos).*alpha(pos);
  obj = OBJ;
  
function salida=examineExample(i2)
  global Y alpha grad C nonboundSV K OBJ s Eta  tol

  
  y2 = Y(i2);
  a2 = alpha(i2);
  grad2 = grad(i2);
  
 
  if ((grad2 < -tol) & a2 > 1e-6) | ((grad2 > tol)&(a2 < C-1e-10))
    % kkt violation
    % make an update of a2
    a2n = a2 + Eta*grad2;
    if a2n < 0
      a2n = 0;
    end
    if a2n > C
      a2n = C;
    end
    if abs(a2-a2n) < eps*(a2+a2n+eps)
      salida = 0;
      return 
    else
      salida = 1; 
      alpha(i2) = a2n;
    end
    
    %update OBJ
    a202 = a2*a2;
    a2n2 = a2n*a2n;
    
    v = s(i2) - y2*a2*K(i2,i2);
    oo=OBJ;
    OBJ = OBJ + ((a2n-a2)+.5*(K(i2,i2)*(a202-a2n2))+ y2*(a2-a2n)*v);
    
  
    % update gradient
    s = s + (a2n-a2)*y2*K(:,i2);
    grad = 1-Y.*s;
    
    
    % update nonbound SV
    if (a2n<C) & (a2n>0)  
      nonboundSV(i2) = 1;
    else
      nonboundSV(i2) = 0;
    end
    return
  end
  salida = 0;
  return
  
      